# -*- coding: utf-8 -*-

#   This file is part of emesene.
#
#    Emesene is free software; you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation; either version 2 of the License, or
#    (at your option) any later version.
#
#    emesene is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with emesene; if not, write to the Free Software
#    Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA

import gtk
from emesenecommon import DIR_SEP
import sha
import shutil

class CustomEmoticons( object ):
    def __init__( self, msn, config ):
        self.msn = msn
        self.config = config
        self.msnOM = msn.getMsnObjectsManager()
        self.list = {}
        self.CEPath = self.config.getCustomEmoticonsPath()
        self.loadMap()
        
    def create( self, shortcut, filename ):
        pixbuf = gtk.gdk.pixbuf_new_from_file( filename )
        type = 'png'
        if gtk.gdk.pixbuf_get_file_info(filename)[0]['name']=='gif':
            type = 'gif'
        
        f = file(filename, 'rb')
        hash = sha.new(f.read()).hexdigest()
        f.close()
        
        dest = self.CEPath + DIR_SEP + hash + '.' + type
        if type == 'gif':
            shutil.copyfile( filename, dest )
        else:
            pixbuf.save( dest, type )
        self.msnOM.create( id=shortcut, filename=dest, type=2 )
        self.list.update( {shortcut:dest} )
        self.saveMap()
    
    def remove( self, id ):
        msnOM = self.msn.getMsnObjectsManager()
        self.updateConfig()
        
    def saveMap( self ):
        try:
            map = open(self.CEPath + DIR_SEP + "map", "w")
        
            for k, v in self.list.iteritems():
                map.write(k + '\n' + v + '\r\n')

            map.close()
        except Exception, e:
            print 'exception writing config:\n'
            print e
            
    def loadMap( self ):
        try:
            self.list = {}
            map = open(self.CEPath + DIR_SEP + "map", "r")
            string = map.read()
            map.close()
            for i in string.split( '\r\n' ):
                if i != '':
                    try:
                        k,v = i.split( '\n' )
                        self.msnOM.create( id=k, filename=v, type=2 )
                        self.list.update( {k:v} )
                    except: print 'Error reading smiley in map file', {k:v}
                    
        except:
            print 'Error reading all smiley in map file', self.CEPath + DIR_SEP + "map"
            self.list = {}