# -*- coding: utf-8 -*-

#   This file is part of emesene.
#
#    Emesene is free software; you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation; either version 2 of the License, or
#    (at your option) any later version.
#
#    emesene is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with emesene; if not, write to the Free Software
#    Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA

import gtk

class FilterEntry( gtk.HBox ):
    
    def __init__( self, callback ):
        ''' the callback is a function that receive
        the string typed here as only parameter'''
        
        gtk.HBox.__init__( self )
        self.set_border_width( 4 )
        self.set_spacing( 4 )
        self.callback = callback
        
        self.entry = gtk.Entry()
        self.entry.connect( "changed", self.entryChanged )
        iconInfo = gtk.icon_theme_get_default().lookup_icon( gtk.STOCK_FIND, 22, 0 )

        self.icon = None

        if iconInfo != None:
            self.icon = gtk.Image()
            self.icon.set_from_pixbuf( iconInfo.load_icon() )
            self.pack_start( self.icon, False, False )
            
        self.pack_start( self.entry )
        
        self.show_all()
            
    def entryChanged( self, *args ):
        self.callback( self.entry.get_text() )
        
