# -*- coding: utf-8 -*-

#   This file is part of emesene.
#
#    Emesene is free software; you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation; either version 2 of the License, or
#    (at your option) any later version.
#
#    emesene is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with emesene; if not, write to the Free Software
#    Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA

import gtk

class Loading( gtk.VBox ):
    "This class represents the loading widget that you see when you login"
    
    def __init__( self , controller ):
        "Constructor"
        
        gtk.VBox.__init__( self )
                
        self.controller = controller
        self.theme = self.controller.theme
        
        self.pack_start( gtk.Label( "" ) )            

        pixbuf = self.theme.getImage( 'loading', True )
        self.loading = gtk.image_new_from_animation( pixbuf )
        self.pack_start( self.loading, False, False )
        
        hbox = gtk.HBox()
        cancelButton = gtk.Button( _( 'Cancel' ), gtk.STOCK_CANCEL )
        cancelButton.connect( 'clicked', self.onCancelActivated )
        self.pack_start( gtk.Label( "" ) )
        hbox.pack_start( gtk.Label( "" ) )
        hbox.pack_start( cancelButton )
        hbox.pack_start( gtk.Label( "" ) )
        
        self.pack_start( hbox, False, False )
        self.pack_start( gtk.Label( "" ) )
                    
        self.show_all()
        
    def onCancelActivated(self,*args):
        self.controller.cancelLogin()

    