# -*- coding: utf-8 -*-

#   This file is part of emesene.
#
#    Eval plugin is free software; you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation; either version 2 of the License, or
#    (at your option) any later version.
#
#    Eval plugin is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with emesene; if not, write to the Free Software
#    Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA

"""
Eval plugin v0.3
THIS IS A DEVELOPERS TOOL, USE AT YOUR OWN RISK!
Simple usage:
 /eval "somestring"
 /eval dir()
 /eval slashAction.conversation.switchboard
Known bugs:
 -Breaks gettext. Really weird. I workarounded it with lambda x:x.
  That means that after using /eval, your emesene will start to translate
  into english
 -Replaces sys.stdout to display the results. So, it can send you some
  unwanted data.
"""

VERSION = '0.3'

import gobject
import sys, code

import Plugin
from emesenecommon import *

class MainClass( Plugin.Plugin ):
    '''Main plugin class'''
    
    def __init__( self, controller, msn ):
        '''Contructor'''
        
        Plugin.Plugin.__init__( self, controller, msn )
        
        self.description = 'Evaluate a python command - USE AT YOUR OWN RISK. (more info in the module docstring)'
        self.authors = { 'Dx' : 'dx@dxzone.com.ar' }
        self.website = 'http://www.dxzone.com.ar'
        self.displayName = 'Eval'
        self.name = 'Eval'
        self.catchOutput = False
        self.controller = controller
        self.Slash = controller.Slash
               
    def start( self ):
        '''start the plugin'''
        self.Slash.register('eval', self.slashCommand, 'Run a python command')
        self.Slash.register('resurrect', self.resurrect, 'Add a new msn.process() timeout')

        self.enabled = True
        
    def slashCommand( self, slashAction ):
        data = str(slashAction.getParams())
        _ = None
        co = self.catchOutput
        if co: oldstdout = sys.stdout
        conversation = slashAction.conversation
        controller = self.controller
        msn = controller.getMSN()
        try:
            if co: sys.stdout = SlashOut(slashAction)
            retval = eval(data)
            slashAction.outputText( 'Return value: ' + str(retval) )
        except:
            exception=sys.exc_info()
            slashAction.outputText( 'Exception %s: %s' % (str(exception[0]), str(exception[1])))
        if co: sys.stdout = oldstdout

    def resurrect( self, slashAction ):
        id = gobject.timeout_add( 200 , self.controller.process )
        slashAction.outputText('Timeout id: %s' % id)

    def stop( self ):    
        '''stop the plugin'''
        self.Slash.unregister('eval')
        self.Slash.unregister('resurrect')
        self.enabled = False
        
    def check( self ):
        return ( True, 'Ok' )


# kept for historical purposes (?)
class FakeOut:
    def __init__(self):
        self.encoding = self.mode = self.name = self.newlines = None
        self.closed = False
        self.softspace = 0
    def close(self):
        pass
    def fileno(self):
        pass
    def flush(self):
        pass
    def isatty(self):
        pass
    def read(self):
        pass
    def tell(self):
        pass
    def write(self):
        pass
    def writelines(self):
        pass

class SlashOut(FakeOut):
    def __init__(self, slashAction):
        FakeOut.__init__(self)
        self.slashAction = slashAction
    def write(self,text):
        self.slashAction.outputText(text)
