# -*- coding: utf-8 -*-

#   This file is part of emesene.
#
#    Emesene is free software; you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation; either version 2 of the License, or
#    (at your option) any later version.
#
#    emesene is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with emesene; if not, write to the Free Software
#    Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA

VERSION = '0.2'

import os

import CurrentSong

error = False

try:
    import pydcop
except:
    error = True
    
class Amarok( CurrentSong.CurrentSong ):

    def __init__( self ):
        CurrentSong.CurrentSong.__init__( self )
        
        self.amarok = None
        self.check()
     
    def isRunning( self ):
        if os.system( "ps aux|grep dcopserver|grep -v grep" ) == 0 and\
        "amarok" in pydcop.apps():
            return True
        return False
        
    def isPlaying( self ):
        if self.amarok != None and self.amarok.player.isPlaying():
            return True    
            
        return False
        
    def getStatus( self ):
        '''check if everything is OK to start the plugin
        return a tuple whith a boolean and a message
        if OK -> ( True , 'some message' )
        else -> ( False , 'error message' )'''
        global error
        
        if error:
            return ( False, _( "Can't import pydcop (try installing python-dcop or similar)" ) )
            
        if os.system( "ps aux|grep dcopserver|grep -v grep" ) != 0:
            return ( False, _( "dcop not running" ) )
        
        if os.name != 'posix':
            return ( False, _( 'This plugin only works in posix systems' ) )
        
        if not self.is_on_path( 'dcop' ):
            return ( False, _( 'Dcop not found' ) )
        
        return ( True, 'Ok' )
        
    def check( self ):
        global error
        
        if error:
            return False
            
        if self.amarok == None and self.isRunning():
            self.amarok = pydcop.DCOPApplication( "amarok" )
            
        if self.isPlaying():
            artist = self.amarok.player.artist()
            title = self.amarok.player.title()
            album = self.amarok.player.album()
            if self.artist != artist or self.title != title:
                self.artist = artist
                self.title = title
                self.album = album
                
                return True
            
        return False
